export declare enum HTTPMethod {
    POST = "POST",
    GET = "GET",
    PATCH = "PATCH",
    PUT = "PUT",
    DELETE = "DELETE",
    HEAD = "HEAD",
    CONNECT = "CONNECT",
    TRACE = "TRACE"
}
declare type ErrorHandlerType<T> = (error: T) => void;
export declare class RequestBuilder {
    private debug;
    private route;
    private body;
    private headers;
    private method;
    private mode;
    private errorHandling;
    private timeout;
    constructor(route: string, debug?: boolean);
    withAuth0Body(body?: Record<string, unknown>): this;
    withErrorHandling<T>(callback: ErrorHandlerType<T>): this;
    withBody(body?: Record<string, unknown>): this;
    withHeaders(headers: Headers): this;
    withMethod(method: HTTPMethod): this;
    withMode(mode: RequestMode): this;
    withTimeout(timeout: number): this;
    private request;
    build<T>(): Promise<T>;
}
export {};
