import { TokenUtil } from "./TokenUtilities";
export class HeadersBuilder {
    constructor() {
        this.headers = new Headers();
        return this;
    }
    withKeyValuePair(key, value) {
        this.headers.append(key, value);
        return this;
    }
    withContentTypeJson() {
        this.headers.append("Content-Type", "application/json");
        return this;
    }
    withToken(type, token) {
        this.headers.append("Authorization", `${type} ${token}`);
        return this;
    }
    withRBAuthToken() {
        this.headers.append("Authorization", `${TokenUtil.getTokens().tokenType} ${TokenUtil.getTokens().accessToken}`);
        return this;
    }
    build() {
        return this.headers;
    }
}
//# sourceMappingURL=HeadersUtil.js.map