import React, { useEffect } from "react";
import { BaseAuthApiWrapper } from "../authServices/BaseAuthApiWrapper";
import { AuthContext, RBAuthInitialUser } from "../roles-based-auth/context";
export const Auth = ({ children, authApi, routes, onAuthExpired, appApis = {}, monitorUserChanges = null, }) => {
    const [reloading, setReloading] = React.useState(true);
    const [user, setUser] = React.useState(null);
    const logic = new BaseAuthApiWrapper(setReloading, setUser, authApi, onAuthExpired, appApis);
    useEffect(() => {
        if (monitorUserChanges)
            monitorUserChanges(user);
    }, [user]);
    const contextVal = {
        isAuth: !!(user && user.role && user.role !== "public"),
        reloading,
        logic,
        routes: {
            private: (routes === null || routes === void 0 ? void 0 : routes.private) || "/private",
            public: (routes === null || routes === void 0 ? void 0 : routes.public) || "/",
        },
        user: user || RBAuthInitialUser,
        rules: {
            admin: {},
            public: {},
        },
    };
    return (React.createElement(AuthContext.Provider, { value: contextVal }, children));
};
//# sourceMappingURL=Auth.js.map