import React from "react";
import { AuthContext } from "../roles-based-auth/context";
/**
 * Check function
 */
const check = (rules, role, action, data) => {
    const permissions = rules[role];
    // role is not present in the rules
    if (!permissions)
        return false;
    // static rule not provided for action
    if (permissions.static && permissions.static.includes(action))
        return true;
    if (permissions.dynamic) {
        const permissionCondition = permissions.dynamic[action];
        // dynamic rule not provided for action
        if (!permissionCondition)
            return false;
        return permissionCondition(data);
    }
    return false;
};
export const Can = ({ role, perform, data = {}, yes = () => null, no = () => null, }) => (React.createElement(AuthContext.Consumer, null, ({ rules }) => (check(rules, role, perform, data) ? yes() : no())));
//# sourceMappingURL=Can.js.map