import React, { useContext, useState, useEffect } from "react";
import { AuthContext } from "../roles-based-auth/context";
class FirstRun {
}
FirstRun.done = false;
export const RefreshApp = ({ children, locationPathName, AuthReloadingComp, AuthLoadingComp = undefined, authCallbackRoute, onReloadFinished, debug = false, }) => {
    const auth = useContext(AuthContext);
    const [isReloading, setIsReloading] = useState(true);
    useEffect(() => {
        if (auth.reloading && AuthLoadingComp !== undefined)
            setIsReloading(true);
        else
            setIsReloading(false);
    }, [auth.reloading, AuthLoadingComp]);
    let silentSwallow = () => { };
    useEffect(() => {
        if (!FirstRun.done && locationPathName !== authCallbackRoute) {
            FirstRun.done = true;
            const onFinally = () => {
                if (onReloadFinished)
                    onReloadFinished();
            };
            if (debug) {
                // eslint-disable-next-line no-console
                silentSwallow = console.log;
                console.log("will issue silent auth");
            }
            auth.logic
                .silent()
                .then(silentSwallow)
                .catch(silentSwallow)
                .finally(onFinally);
        }
    }, [auth.logic, authCallbackRoute, debug, locationPathName]);
    if (!FirstRun.done && AuthReloadingComp)
        return React.createElement(AuthReloadingComp, null);
    else
        return (React.createElement(React.Fragment, null,
            isReloading && AuthLoadingComp && React.createElement(AuthLoadingComp, null),
            children));
};
//# sourceMappingURL=RefreshApp.js.map