var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
/* eslint-disable no-console */
import { createContext } from "react";
export const RBAuthInitialUser = {
    role: "public",
};
export const RBAuthInitialToken = {
    accessToken: "",
    refreshToken: "",
    openIdToken: "",
    tokenType: "",
    expiresIn: "",
    scope: "",
};
export const AuthContext = createContext({
    // to check if authenticated or not
    isAuth: false,
    reloading: true,
    // store user
    user: RBAuthInitialUser,
    // accessToken of user for Auth0
    logic: {
        // login process
        login: () => __awaiter(void 0, void 0, void 0, function* () { return console.log("please change login"); }),
        // signup process
        signup: () => __awaiter(void 0, void 0, void 0, function* () { return console.log("please change signup"); }),
        // logout the user
        logout: () => __awaiter(void 0, void 0, void 0, function* () { return console.log("please change logout"); }),
        silent: () => __awaiter(void 0, void 0, void 0, function* () { return console.log("please change silent"); }),
        // handle Auth0 login process
        handle: () => __awaiter(void 0, void 0, void 0, function* () { return console.log("please change handle"); }),
        refresh: () => __awaiter(void 0, void 0, void 0, function* () { return console.log("please change refresh"); }),
        apis: {},
    },
    routes: {
        public: "/",
        private: "/dashboard",
    },
    rules: {
        // visitor permissions
        public: {
            static: ["home-page:visit"],
        },
        // admin permissions
        admin: {
            static: ["home-page:visit", "dashboard-page:visit"],
        },
    },
});
//# sourceMappingURL=context.js.map