function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;

  _setPrototypeOf(subClass, superClass);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

// A type of promise-like that resolves synchronously and supports only one observer

const _iteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.iterator || (Symbol.iterator = Symbol("Symbol.iterator"))) : "@@iterator";

const _asyncIteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.asyncIterator || (Symbol.asyncIterator = Symbol("Symbol.asyncIterator"))) : "@@asyncIterator";

// Asynchronously call a function and send errors to recovery continuation
function _catch(body, recover) {
	try {
		var result = body();
	} catch(e) {
		return recover(e);
	}
	if (result && result.then) {
		return result.then(void 0, recover);
	}
	return result;
}

// Asynchronously await a promise and pass the result to a finally continuation
function _finallyRethrows(body, finalizer) {
	try {
		var result = body();
	} catch (e) {
		return finalizer(true, e);
	}
	if (result && result.then) {
		return result.then(finalizer.bind(null, false), finalizer.bind(null, true));
	}
	return finalizer(false, result);
}

var RBAuthInitialUser = {
  role: 'public'
};
var RBAuthInitialToken = {
  accessToken: '',
  refreshToken: '',
  openIdToken: '',
  tokenType: '',
  expiresIn: '',
  scope: ''
};
var AuthContext = React.createContext({
  isAuth: false,
  reloading: true,
  user: RBAuthInitialUser,
  logic: {
    login: function () {
      try {
        return Promise.resolve(console.log('please change login'));
      } catch (e) {
        return Promise.reject(e);
      }
    },
    signup: function () {
      try {
        return Promise.resolve(console.log('please change signup'));
      } catch (e) {
        return Promise.reject(e);
      }
    },
    logout: function () {
      try {
        return Promise.resolve(console.log('please change logout'));
      } catch (e) {
        return Promise.reject(e);
      }
    },
    silent: function () {
      try {
        return Promise.resolve(console.log('please change silent'));
      } catch (e) {
        return Promise.reject(e);
      }
    },
    handle: function () {
      try {
        return Promise.resolve(console.log('please change handle'));
      } catch (e) {
        return Promise.reject(e);
      }
    },
    refresh: function () {
      try {
        return Promise.resolve(console.log('please change refresh'));
      } catch (e) {
        return Promise.reject(e);
      }
    },
    apis: {}
  },
  routes: {
    "public": '/',
    "private": '/dashboard'
  },
  rules: {
    "public": {
      "static": ['home-page:visit']
    },
    admin: {
      "static": ['home-page:visit', 'dashboard-page:visit']
    }
  }
});

var initialStorage = {
  accessToken: '',
  refreshToken: '',
  openIdToken: '',
  tokenType: '',
  expiresIn: '',
  scope: '',
  setTokens: function setTokens() {
    return null;
  }
};
var TokenUtil = /*#__PURE__*/function () {
  function TokenUtil() {}

  TokenUtil.setStorage = function setStorage(storage) {
    TokenUtil.s = storage;
  };

  TokenUtil.getTokens = function getTokens() {
    return {
      accessToken: TokenUtil.s.accessToken || '',
      refreshToken: TokenUtil.s.refreshToken || '',
      openIdToken: TokenUtil.s.openIdToken || '',
      tokenType: TokenUtil.s.tokenType || '',
      expiresIn: TokenUtil.s.expiresIn || '',
      scope: TokenUtil.s.scope || ''
    };
  };

  return TokenUtil;
}();
TokenUtil.s = initialStorage;

TokenUtil.setTokens = function (t) {
  if (t === void 0) {
    t = RBAuthInitialToken;
  }

  return TokenUtil.s.setTokens(t);
};

(function (RBAuthErrors) {
  RBAuthErrors["INVALID_GRANT"] = "invalid_grant";
  RBAuthErrors["REFRESH_TOKEN_REVOKED"] = "refreshTokenRevoked";
  RBAuthErrors["REFRESH_TOKEN_NOT_PRESENT"] = "noRefreshToken";
  RBAuthErrors["UNAUTHORIZED"] = "Unauthorized";
  RBAuthErrors["TOO_MANY_REQUESTS"] = "Too Many Requests";
  RBAuthErrors["FAILLED_TO_FETCH"] = "failled to fetch";
  RBAuthErrors["UNKNOWN"] = "UNKNOWN";
})(exports.RBAuthErrors || (exports.RBAuthErrors = {}));

var RECUR_LEVEL = 1;

var RequestWrapper = /*#__PURE__*/function () {
  function RequestWrapper() {}

  RequestWrapper.handle = function handle(request, onSuccess, onFailure, recursion, accessTokenError, refresTokenError) {
    if (recursion === void 0) {
      recursion = RECUR_LEVEL;
    }

    if (accessTokenError === void 0) {
      accessTokenError = exports.RBAuthErrors.UNAUTHORIZED;
    }

    if (refresTokenError === void 0) {
      refresTokenError = exports.RBAuthErrors.INVALID_GRANT;
    }

    return function (refreshLogic) {
      return function () {
        try {
          return Promise.resolve(RequestWrapper.recursion(refreshLogic, request, onSuccess, onFailure, recursion, accessTokenError, refresTokenError));
        } catch (e) {
          return Promise.reject(e);
        }
      };
    };
  };

  return RequestWrapper;
}();

RequestWrapper.recursion = function (refresh, req, onSuccess, onFailure, recursion, accessTokenError, refresTokenError) {
  if (recursion === void 0) {
    recursion = RECUR_LEVEL;
  }

  try {
    if (accessTokenError === undefined) accessTokenError = exports.RBAuthErrors.UNAUTHORIZED;
    if (refresTokenError === undefined) refresTokenError = exports.RBAuthErrors.INVALID_GRANT;
    return Promise.resolve(_catch(function () {
      return Promise.resolve(req()).then(function () {});
    }, function (e) {
      var _exit = false;

      function _temp2(_result2) {
        if (_exit) return _result2;
        throw e;
      }

      var _temp = function () {
        if (e.message === accessTokenError && recursion >= 1) {
          return _catch(function () {
            return Promise.resolve(refresh()).then(function () {
              _exit = true;
              return RequestWrapper.recursion(refresh, req, onSuccess, onFailure, recursion - 1, accessTokenError, refresTokenError);
            });
          }, function () {
            onFailure(exports.RBAuthErrors.REFRESH_TOKEN_REVOKED);
            throw new Error(exports.RBAuthErrors.REFRESH_TOKEN_REVOKED);
          });
        } else {
          onFailure(e);
        }
      }();

      return _temp && _temp.then ? _temp.then(_temp2) : _temp2(_temp);
    }));
  } catch (e) {
    return Promise.reject(e);
  }
};

var ApiAccessBuilder = /*#__PURE__*/function () {
  function ApiAccessBuilder(logic) {
    this.success = function () {
      return null;
    };

    this.failure = function () {
      return null;
    };

    this.recursions = RECUR_LEVEL;
    this.accessTokenError = exports.RBAuthErrors.INVALID_GRANT;
    this.refreshTokenError = exports.RBAuthErrors.REFRESH_TOKEN_REVOKED;
    this.logic = logic;
  }

  var _proto = ApiAccessBuilder.prototype;

  _proto.withAccessTokenError = function withAccessTokenError(accessTokenError) {
    this.accessTokenError = accessTokenError;
    return this;
  };

  _proto.withRefreshTokenError = function withRefreshTokenError(refreshTokenError) {
    this.refreshTokenError = refreshTokenError;
    return this;
  };

  _proto.withSuccess = function withSuccess(success) {
    this.success = success;
    return this;
  };

  _proto.withFailure = function withFailure(failure) {
    this.failure = failure;
    return this;
  };

  _proto.withCustomRecursions = function withCustomRecursions(recursions) {
    this.recursions = recursions;
    return this;
  };

  _proto.build = function build(refresh) {
    return RequestWrapper.handle(this.logic, this.success, this.failure, this.recursions, this.accessTokenError, this.refreshTokenError)(refresh);
  };

  return ApiAccessBuilder;
}();

var UserReloader = function UserReloader(setReloading, setUser) {
  this.setReloading = setReloading;
  this.setUser = setUser;
};

var dummyFunction = function dummyFunction(arg) {
  return new Promise(function (r) {
    return r(arg);
  });
};

var BaseAuthApiWrapper = /*#__PURE__*/function (_UserReloader) {
  _inheritsLoose(BaseAuthApiWrapper, _UserReloader);

  function BaseAuthApiWrapper(setReloading, setUser, processes, refreshTokenEndLifeCallback, appApis) {
    var _this;

    _this = _UserReloader.call(this, setReloading, setUser) || this;
    _this.defaultLogin = dummyFunction;
    _this.defaultLogout = dummyFunction;
    _this.defaultSignupLogic = dummyFunction;
    _this.defaultSilentLogic = dummyFunction;
    _this.defaultHandleLogic = dummyFunction;
    _this.defaultRefreshLogic = dummyFunction;
    _this.loginLogic = _this.defaultLogin;
    _this.logoutLogic = _this.defaultLogout;
    _this.signupLogic = _this.defaultSignupLogic;
    _this.silentLogic = _this.defaultSilentLogic;
    _this.handleLogic = _this.defaultHandleLogic;
    _this.refreshLogic = _this.defaultRefreshLogic;

    _this.errorCallback = function () {
      return null;
    };

    _this.appApis = {};

    _this.login = function () {
      try {
        return Promise.resolve(_this.runLogic(_this.loginLogic).apply(void 0, arguments));
      } catch (e) {
        return Promise.reject(e);
      }
    };

    _this.handle = function () {
      try {
        return Promise.resolve(_this.runLogic(_this.handleLogic).apply(void 0, arguments));
      } catch (e) {
        return Promise.reject(e);
      }
    };

    _this.silent = function () {
      try {
        return Promise.resolve(_this.runLogic(_this.silentLogic).apply(void 0, arguments));
      } catch (e) {
        return Promise.reject(e);
      }
    };

    _this.signup = function () {
      var _this2;

      return (_this2 = _this).signupLogic.apply(_this2, arguments);
    };

    _this.refresh = function (f) {
      try {
        return Promise.resolve(_this.runRefresh(_this.refreshLogic)(f));
      } catch (e) {
        return Promise.reject(e);
      }
    };

    _this.logout = function () {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      try {
        return Promise.resolve(_this.wrap(function () {
          try {
            var _this3;

            return Promise.resolve((_this3 = _this).logoutLogic.apply(_this3, args)).then(function (res) {
              return Promise.resolve(_this.authenticate()).then(function () {
                return res;
              });
            });
          } catch (e) {
            return Promise.reject(e);
          }
        }));
      } catch (e) {
        return Promise.reject(e);
      }
    };

    _this.runLogic = function (logic) {
      return function () {
        for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
          args[_key2] = arguments[_key2];
        }

        try {
          return Promise.resolve(_this.wrap(function () {
            try {
              return Promise.resolve(logic.apply(void 0, args)).then(function (res) {
                return Promise.resolve(_this.authenticate(res)).then(function () {
                  return res;
                });
              });
            } catch (e) {
              return Promise.reject(e);
            }
          }));
        } catch (e) {
          return Promise.reject(e);
        }
      };
    };

    _this.runRefresh = function (logic) {
      return function (flag) {
        try {
          return Promise.resolve(_this.wrap(function () {
            try {
              return Promise.resolve(logic()).then(function (res) {
                var _temp = function () {
                  if (res.refreshToken) return Promise.resolve(TokenUtil.setTokens(res)).then(function () {});
                }();

                return _temp && _temp.then ? _temp.then(function () {
                  return res;
                }) : res;
              });
            } catch (e) {
              return Promise.reject(e);
            }
          }, flag));
        } catch (e) {
          return Promise.reject(e);
        }
      };
    };

    _this.accessTokenError = exports.RBAuthErrors.UNAUTHORIZED;
    _this.refreshTokenError = exports.RBAuthErrors.INVALID_GRANT;

    _this.apiWrap = function (logic) {
      return function (onSuccess, onError) {
        return new ApiAccessBuilder(logic).withSuccess(onSuccess).withFailure(onError).withAccessTokenError(_this.accessTokenError).withRefreshTokenError(_this.refreshTokenError).build(_this.refresh);
      };
    };

    _this.wrap = function (logic, flag) {
      if (flag === void 0) {
        flag = true;
      }

      try {
        if (flag) _this.setReloading(true);
        return Promise.resolve(_finallyRethrows(function () {
          return _catch(logic, function (e) {
            if (e.message === 'Failed to fetch') _this.errorCallback(exports.RBAuthErrors.FAILLED_TO_FETCH, e);else if (e.message === exports.RBAuthErrors.UNAUTHORIZED) _this.errorCallback(e);else if (e.message === exports.RBAuthErrors.REFRESH_TOKEN_NOT_PRESENT) {} else if (e.message !== exports.RBAuthErrors.REFRESH_TOKEN_NOT_PRESENT) _this.errorCallback(exports.RBAuthErrors.UNKNOWN, e);
            throw e;
          });
        }, function (_wasThrown, _result) {
          if (flag) _this.setReloading(false);
          if (_wasThrown) throw _result;
          return _result;
        }));
      } catch (e) {
        return Promise.reject(e);
      }
    };

    _this.authenticate = function (res) {
      if (res === void 0) {
        res = null;
      }

      try {
        var _temp3 = function () {
          if (res && res.user && res.tokens) {
            _this.setUser(res.user);

            return Promise.resolve(TokenUtil.setTokens(res.tokens)).then(function () {});
          } else {
            _this.setUser(null);

            return Promise.resolve(TokenUtil.setTokens(RBAuthInitialToken)).then(function () {});
          }
        }();

        return Promise.resolve(_temp3 && _temp3.then ? _temp3.then(function () {}) : void 0);
      } catch (e) {
        return Promise.reject(e);
      }
    };

    if (refreshTokenEndLifeCallback) _this.errorCallback = refreshTokenEndLifeCallback;
    if (appApis) _this.appApis = _this.embedWrapperLogicIntoApis(appApis);
    if (!processes) return _assertThisInitialized(_this);
    if (processes.login) _this.loginLogic = processes.login;
    if (processes.logout) _this.logoutLogic = processes.logout;
    if (processes.signup) _this.signupLogic = processes.signup;
    if (processes.handle) _this.handleLogic = processes.handle;
    if (processes.silent) _this.silentLogic = processes.silent;
    if (processes.refresh) _this.refreshLogic = processes.refresh;
    return _this;
  }

  var _proto = BaseAuthApiWrapper.prototype;

  _proto.embedWrapperLogicIntoApis = function embedWrapperLogicIntoApis(apis) {
    var _this4 = this;

    var result = {};
    Object.keys(apis).forEach(function (item) {
      if (item.startsWith('logic') && apis[item] && typeof apis[item] === 'function') result[item] = _this4.apiWrap(apis[item]);else if (apis[item] !== null && typeof apis[item] === 'object') result[item] = _this4.embedWrapperLogicIntoApis(apis[item]);else result[item] = apis[item];
    });
    return result;
  };

  _createClass(BaseAuthApiWrapper, [{
    key: "apis",
    get: function get() {
      return this.appApis;
    }
  }]);

  return BaseAuthApiWrapper;
}(UserReloader);

var Auth = function Auth(_ref) {
  var children = _ref.children,
      authApi = _ref.authApi,
      routes = _ref.routes,
      onAuthExpired = _ref.onAuthExpired,
      _ref$appApis = _ref.appApis,
      appApis = _ref$appApis === void 0 ? {} : _ref$appApis,
      _ref$monitorUserChang = _ref.monitorUserChanges,
      monitorUserChanges = _ref$monitorUserChang === void 0 ? null : _ref$monitorUserChang;

  var _React$useState = React__default.useState(true),
      reloading = _React$useState[0],
      setReloading = _React$useState[1];

  var _React$useState2 = React__default.useState(null),
      user = _React$useState2[0],
      setUser = _React$useState2[1];

  var logic = new BaseAuthApiWrapper(setReloading, setUser, authApi, onAuthExpired, appApis);
  React.useEffect(function () {
    if (monitorUserChanges) monitorUserChanges(user);
  }, [user]);
  var contextVal = {
    isAuth: !!(user && user.role && user.role !== 'public'),
    reloading: reloading,
    logic: logic,
    routes: {
      "private": (routes === null || routes === void 0 ? void 0 : routes["private"]) || '/private',
      "public": (routes === null || routes === void 0 ? void 0 : routes["public"]) || '/'
    },
    user: user || RBAuthInitialUser,
    rules: {
      admin: {},
      "public": {}
    }
  };
  return /*#__PURE__*/React__default.createElement(AuthContext.Provider, {
    value: contextVal
  }, children);
};

var AuthCallback = function AuthCallback(_ref) {
  var children = _ref.children,
      locationHash = _ref.locationHash,
      Redirect = _ref.Redirect;
  return /*#__PURE__*/React__default.createElement(AuthContext.Consumer, null, function (auth) {
    if (/access_token|id_token|error/.test(locationHash)) {
      auth.logic.handle();
      return /*#__PURE__*/React__default.createElement(Fragment, null);
    }

    if (Redirect) return /*#__PURE__*/React__default.createElement(Redirect, {
      to: auth.routes["public"]
    });else {
      console.log('AuthCallback has no redirect, be sure handleAuthentication has programatic redirection');
    }
    return /*#__PURE__*/React__default.createElement(Fragment, null, children);
  });
};

var FirstRun = function FirstRun() {};

FirstRun.done = false;
var RefreshApp = function RefreshApp(_ref) {
  var children = _ref.children,
      locationPathName = _ref.locationPathName,
      AuthReloadingComp = _ref.AuthReloadingComp,
      _ref$AuthLoadingComp = _ref.AuthLoadingComp,
      AuthLoadingComp = _ref$AuthLoadingComp === void 0 ? undefined : _ref$AuthLoadingComp,
      authCallbackRoute = _ref.authCallbackRoute,
      onRefreshFinished = _ref.onRefreshFinished,
      _ref$debug = _ref.debug,
      debug = _ref$debug === void 0 ? false : _ref$debug;
  var auth = React.useContext(AuthContext);

  var _useState = React.useState(true),
      isReloading = _useState[0],
      setIsReloading = _useState[1];

  React.useEffect(function () {
    if (auth.reloading && AuthLoadingComp !== undefined) setIsReloading(true);else setIsReloading(false);
  }, [auth.reloading, AuthLoadingComp]);
  React.useEffect(function () {
    if (!FirstRun.done && locationPathName !== authCallbackRoute) {
      FirstRun.done = true;

      var silentSwallowFunc = function silentSwallowFunc() {};

      var onRefreshFinishedHandler = function onRefreshFinishedHandler() {
        if (debug) console.log('Finished refreshing');
        if (onRefreshFinished) onRefreshFinished();
      };

      if (debug) silentSwallowFunc = console.log;
      auth.logic.silent().then(silentSwallowFunc)["catch"](silentSwallowFunc)["finally"](onRefreshFinishedHandler);
    }
  }, []);
  if (!FirstRun.done && AuthReloadingComp) return /*#__PURE__*/React__default.createElement(AuthReloadingComp, null);else return /*#__PURE__*/React__default.createElement(React__default.Fragment, null, isReloading && AuthLoadingComp && /*#__PURE__*/React__default.createElement(AuthLoadingComp, null), children);
};

var SecureScreen = function SecureScreen(_ref) {
  var Redirect = _ref.Redirect,
      Allowed = _ref.Allowed,
      NotAllowed = _ref.NotAllowed;
  return /*#__PURE__*/React__default.createElement(AuthContext.Consumer, null, function (auth) {
    if (!auth.isAuth) {
      var _auth$routes;

      if (NotAllowed) return /*#__PURE__*/React__default.createElement(NotAllowed, null);
      return /*#__PURE__*/React__default.createElement(Redirect, {
        to: ((_auth$routes = auth.routes) === null || _auth$routes === void 0 ? void 0 : _auth$routes["public"]) || '/'
      });
    }

    return /*#__PURE__*/React__default.createElement(Allowed, null);
  });
};

var HeadersBuilder = /*#__PURE__*/function () {
  function HeadersBuilder() {
    this.headers = new Headers();
    return this;
  }

  var _proto = HeadersBuilder.prototype;

  _proto.withKeyValuePair = function withKeyValuePair(key, value) {
    this.headers.append(key, value);
    return this;
  };

  _proto.withContentTypeJson = function withContentTypeJson() {
    this.headers.append('Content-Type', 'application/json');
    return this;
  };

  _proto.withToken = function withToken(type, token) {
    this.headers.append('Authorization', type + " " + token);
    return this;
  };

  _proto.withRBAuthToken = function withRBAuthToken() {
    this.headers.append('Authorization', TokenUtil.getTokens().tokenType + " " + TokenUtil.getTokens().accessToken);
    return this;
  };

  _proto.build = function build() {
    return this.headers;
  };

  return HeadersBuilder;
}();

var DEFAULT_TIMEOUT = 10000;
var fetchWithTimeout = function fetchWithTimeout(requestInfo, requestInit, timeout) {
  if (timeout === void 0) {
    timeout = DEFAULT_TIMEOUT;
  }

  return Promise.race([fetch(requestInfo, requestInit), new Promise(function (_resolve, reject) {
    return setTimeout(function () {
      return reject(new Error('timeout'));
    }, timeout);
  })]);
};

(function (HTTPMethod) {
  HTTPMethod["POST"] = "POST";
  HTTPMethod["GET"] = "GET";
  HTTPMethod["PATCH"] = "PATCH";
  HTTPMethod["PUT"] = "PUT";
  HTTPMethod["DELETE"] = "DELETE";
  HTTPMethod["HEAD"] = "HEAD";
  HTTPMethod["CONNECT"] = "CONNECT";
  HTTPMethod["TRACE"] = "TRACE";
})(exports.HTTPMethod || (exports.HTTPMethod = {}));

var RequestBuilder = /*#__PURE__*/function () {
  function RequestBuilder(route, debug) {
    if (debug === void 0) {
      debug = false;
    }

    this.debug = debug;
    this.route = '';
    this.body = null;
    this.headers = new Headers();
    this.method = exports.HTTPMethod.GET;
    this.mode = null;
    this.errorHandling = null;
    this.timeout = DEFAULT_TIMEOUT;
    this.route = route;
    return this;
  }

  var _proto = RequestBuilder.prototype;

  _proto.withAuth0Body = function withAuth0Body(body) {
    if (body === void 0) {
      body = {};
    }

    this.body = body;
    return this;
  };

  _proto.withErrorHandling = function withErrorHandling(callback) {
    this.errorHandling = callback;
    return this;
  };

  _proto.withBody = function withBody(body) {
    if (body === void 0) {
      body = {};
    }

    this.body = body;
    return this;
  };

  _proto.withHeaders = function withHeaders(headers) {
    this.headers = headers;
    return this;
  };

  _proto.withMethod = function withMethod(method) {
    this.method = method;
    return this;
  };

  _proto.withMode = function withMode(mode) {
    this.mode = mode;
    return this;
  };

  _proto.withTimeout = function withTimeout(timeout) {
    this.timeout = timeout;
    return this;
  };

  _proto.request = function request() {
    if (this.debug) {
      var debugHeaders = {};
      this.headers.forEach(function (value, key) {
        return debugHeaders[key] = value;
      });
      console.log('will request: ', this.route, this.method, JSON.stringify(debugHeaders), JSON.stringify(this.body));
    }

    var opts = {
      method: this.method,
      headers: this.headers
    };
    if (this.mode) opts.mode = this.mode;
    if (this.method !== exports.HTTPMethod.GET && this.method !== exports.HTTPMethod.HEAD && this.body) opts.body = JSON.stringify(this.body);
    return fetchWithTimeout(this.route, opts, this.timeout);
  };

  _proto.build = function build() {
    try {
      var _this2 = this;

      return Promise.resolve(_this2.request()).then(function (res) {
        var contentType = res.headers.get('content-type');
        var success = res.ok;

        if (contentType && contentType.indexOf('application/json') !== -1) {
          return Promise.resolve(res.json());
        } else {
          return Promise.resolve(res.text()).then(function (error) {
            if (!success) {
              if (_this2.debug) console.log(error);
              if (_this2.errorHandling) _this2.errorHandling(error);
            }

            return error;
          });
        }
      });
    } catch (e) {
      return Promise.reject(e);
    }
  };

  return RequestBuilder;
}();

var check = function check(rules, role, action, data) {
  var permissions = rules[role];
  if (!permissions) return false;
  if (permissions["static"] && permissions["static"].includes(action)) return true;

  if (permissions.dynamic) {
    var permissionCondition = permissions.dynamic[action];
    if (!permissionCondition) return false;
    return permissionCondition(data);
  }

  return false;
};

var Can = function Can(_ref) {
  var role = _ref.role,
      perform = _ref.perform,
      _ref$data = _ref.data,
      data = _ref$data === void 0 ? {} : _ref$data,
      _ref$yes = _ref.yes,
      yes = _ref$yes === void 0 ? function () {
    return null;
  } : _ref$yes,
      _ref$no = _ref.no,
      no = _ref$no === void 0 ? function () {
    return null;
  } : _ref$no;
  return /*#__PURE__*/React__default.createElement(AuthContext.Consumer, null, function (_ref2) {
    var rules = _ref2.rules;
    return check(rules, role, perform, data) ? yes() : no();
  });
};

exports.ApiAccessBuilder = ApiAccessBuilder;
exports.Auth = Auth;
exports.AuthCallback = AuthCallback;
exports.AuthContext = AuthContext;
exports.BaseAuthApiWrapper = BaseAuthApiWrapper;
exports.Can = Can;
exports.HeadersBuilder = HeadersBuilder;
exports.RBAuthInitialToken = RBAuthInitialToken;
exports.RefreshApp = RefreshApp;
exports.RequestBuilder = RequestBuilder;
exports.SecureScreen = SecureScreen;
exports.TokenUtil = TokenUtil;
//# sourceMappingURL=index.js.map
