import { RBAuthErrors } from "../rb-auth-errors";
declare type RefreshType = (reloadFlag?: boolean) => Promise<Response>;
declare type OnSuccessType = <T>(arg: T) => void;
declare type OnFailureType = (error: RBAuthErrors) => void;
export declare class ApiAccessBuilder {
    private success;
    private failure;
    private recursions;
    private accessTokenError;
    private refreshTokenError;
    private logic;
    constructor(logic: <T>() => Promise<T>);
    withAccessTokenError(accessTokenError: RBAuthErrors): this;
    withRefreshTokenError(refreshTokenError: RBAuthErrors): this;
    withSuccess(success: OnSuccessType): this;
    withFailure(failure: OnFailureType): this;
    withCustomRecursions(recursions: number): this;
    build(refresh: RefreshType): () => Promise<void>;
}
export {};
